OGRE: Ogre::HardwareVertexBuffer Class Reference - OGRE Documentation

Public Types | Public Member Functions | Protected Member Functions | Protected Attributes

# Ogre::HardwareVertexBuffer Class Reference
[RenderSystem]

Specialisation of HardwareBuffer for a vertex buffer. More...

`#include <OgreHardwareVertexBuffer.h>`

Inheritance diagram for Ogre::HardwareVertexBuffer:
[legend]

List of all members.

## Public Types
enum | Usage { HBU_STATIC = 1, HBU_DYNAMIC = 2, HBU_WRITE_ONLY = 4, HBU_DISCARDABLE = 8, HBU_STATIC_WRITE_ONLY = 5, HBU_DYNAMIC_WRITE_ONLY = 6, HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE = 14 }
| Enums describing buffer usage; not mutually exclusive. More...
enum | LockOptions { HBL_NORMAL, HBL_DISCARD, HBL_READ_ONLY, HBL_NO_OVERWRITE }
| Locking options. More...
## Public Member Functions
| HardwareVertexBuffer (HardwareBufferManagerBase *mgr, size_t vertexSize, size_t numVertices, HardwareBuffer::Usage usage, bool useSystemMemory, bool useShadowBuffer)
| Should be called by HardwareBufferManager.
| ~HardwareVertexBuffer ()
HardwareBufferManagerBase * | getManager () const
| Return the manager of this buffer, if any.
size_t | getVertexSize (void) const
| Gets the size in bytes of a single vertex in this buffer.
size_t | getNumVertices (void) const
| Get the number of vertices in this buffer.
virtual void * | lock (size_t offset, size_t length, LockOptions options)
| Lock the buffer for (potentially) reading / writing.
void * | lock (LockOptions options)
| Lock the entire buffer for (potentially) reading / writing.
virtual void | unlock (void)
| Releases the lock on this buffer.
virtual void | readData (size_t offset, size_t length, void *pDest)=0
| Reads data from the buffer and places it in the memory pointed to by pDest.
virtual void | writeData (size_t offset, size_t length, const void *pSource, bool discardWholeBuffer=false)=0
| Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough.
virtual void | copyData (HardwareBuffer &srcBuffer, size_t srcOffset, size_t dstOffset, size_t length, bool discardWholeBuffer=false)
| Copy data from another buffer into this one.
virtual void | copyData (HardwareBuffer &srcBuffer)
| Copy all data from another buffer into this one.
virtual void | _updateFromShadow (void)
| Updates the real buffer from the shadow buffer, if required.
size_t | getSizeInBytes (void) const
| Returns the size of this buffer in bytes.
Usage | getUsage (void) const
| Returns the Usage flags with which this buffer was created.
bool | isSystemMemory (void) const
| Returns whether this buffer is held in system memory.
bool | hasShadowBuffer (void) const
| Returns whether this buffer has a system memory shadow for quicker reading.
bool | isLocked (void) const
| Returns whether or not this buffer is currently locked.
void | suppressHardwareUpdate (bool suppress)
| Pass true to suppress hardware upload of shadow buffer changes.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Protected Member Functions
virtual void * | lockImpl (size_t offset, size_t length, LockOptions options)=0
| Internal implementation of lock().
virtual void | unlockImpl (void)=0
| Internal implementation of unlock().
## Protected Attributes
HardwareBufferManagerBase * | mMgr
size_t | mNumVertices
size_t | mVertexSize
size_t | mSizeInBytes
Usage | mUsage
bool | mIsLocked
size_t | mLockStart
size_t | mLockSize
bool | mSystemMemory
bool | mUseShadowBuffer
HardwareBuffer * | mpShadowBuffer
bool | mShadowUpdated
bool | mSuppressHardwareUpdate

## Detailed Description

Specialisation of HardwareBuffer for a vertex buffer.

Definition at line 47 of file OgreHardwareVertexBuffer.h.

## Member Enumeration Documentation

enum Ogre::HardwareBuffer::LockOptions`[inherited]`

Locking options.

Enumerator:

  HBL_NORMAL | Normal mode, ie allows read/write and contents are preserved.
  HBL_DISCARD | Discards the entire buffer while locking; this allows optimisation to be performed because synchronisation issues are relaxed. Only allowed on buffers created with the HBU_DYNAMIC flag.
  HBL_READ_ONLY | Lock the buffer for reading only. Not allowed in buffers which are created with HBU_WRITE_ONLY. Mandatory on static buffers, i.e. those created without the HBU_DYNAMIC flag.
  HBL_NO_OVERWRITE | As HBL_NORMAL, except the application guarantees not to overwrite any region of the buffer which has already been used in this frame, can allow some optimisation on some APIs.

Definition at line 120 of file OgreHardwareBuffer.h.

enum Ogre::HardwareBuffer::Usage`[inherited]`

Enums describing buffer usage; not mutually exclusive.

Enumerator:

  HBU_STATIC | Static buffer which the application rarely modifies once created. Modifying the contents of this buffer will involve a performance hit.
  HBU_DYNAMIC | Indicates the application would like to modify this buffer with the CPU fairly often. Buffers created with this flag will typically end up in AGP memory rather than video memory.
  HBU_WRITE_ONLY | Indicates the application will never read the contents of the buffer back, it will only ever write data. Locking a buffer with this flag will ALWAYS return a pointer to new, blank memory rather than the memory associated with the contents of the buffer; this avoids DMA stalls because you can write to a new memory area while the previous one is being used.
  HBU_DISCARDABLE | Indicates that the application will be refilling the contents of the buffer regularly (not just updating, but generating the contents from scratch), and therefore does not mind if the contents of the buffer are lost somehow and need to be recreated. This allows and additional level of optimisation on the buffer. This option only really makes sense when combined with HBU_DYNAMIC_WRITE_ONLY.
  HBU_STATIC_WRITE_ONLY | Combination of HBU_STATIC and HBU_WRITE_ONLY.
  HBU_DYNAMIC_WRITE_ONLY | Combination of HBU_DYNAMIC and HBU_WRITE_ONLY. If you use this, strongly consider using HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE instead if you update the entire contents of the buffer very regularly.
  HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE | Combination of HBU_DYNAMIC, HBU_WRITE_ONLY and HBU_DISCARDABLE.

Definition at line 78 of file OgreHardwareBuffer.h.

## Constructor & Destructor Documentation

Ogre::HardwareVertexBuffer::HardwareVertexBuffer | ( | HardwareBufferManagerBase * | mgr,
|  | size_t | vertexSize,
|  | size_t | numVertices,
|  | HardwareBuffer::Usage | usage,
|  | bool | useSystemMemory,
|  | bool | useShadowBuffer |
| ) |  |  |

Should be called by HardwareBufferManager.

Ogre::HardwareVertexBuffer::~HardwareVertexBuffer | ( |  | ) |

## Member Function Documentation

virtual void Ogre::HardwareBuffer::_updateFromShadow | ( | void |  | ) | `[virtual, inherited]`

Updates the real buffer from the shadow buffer, if required.

Definition at line 295 of file OgreHardwareBuffer.h.

virtual void Ogre::HardwareBuffer::copyData | ( | HardwareBuffer & | srcBuffer,
|  | size_t | srcOffset,
|  | size_t | dstOffset,
|  | size_t | length,
|  | bool | discardWholeBuffer = `false` |
| ) |  |  | `[virtual, inherited]`

Copy data from another buffer into this one.

Remarks:
  Note that the source buffer must not be created with the usage HBU_WRITE_ONLY otherwise this will fail.

Parameters:

  | srcBuffer | The buffer from which to read the copied data
  | srcOffset | Offset in the source buffer at which to start reading
  | dstOffset | Offset in the destination buffer to start writing
  | length | Length of the data to copy, in bytes.
  | discardWholeBuffer | If true, will discard the entire contents of this buffer before copying

Definition at line 274 of file OgreHardwareBuffer.h.

References Ogre::HardwareBuffer::lock(), and Ogre::HardwareBuffer::unlock().

virtual void Ogre::HardwareBuffer::copyData | ( | HardwareBuffer & | srcBuffer | ) | `[virtual, inherited]`

Copy all data from another buffer into this one.

Remarks:
  Normally these buffers should be of identical size, but if they're not, the routine will use the smallest of the two sizes.

Definition at line 288 of file OgreHardwareBuffer.h.

References Ogre::HardwareBuffer::getSizeInBytes().

HardwareBufferManagerBase* Ogre::HardwareVertexBuffer::getManager | ( |  | ) | const

Return the manager of this buffer, if any.

Definition at line 61 of file OgreHardwareVertexBuffer.h.

size_t Ogre::HardwareVertexBuffer::getNumVertices | ( | void |  | ) | const

Get the number of vertices in this buffer.

Definition at line 65 of file OgreHardwareVertexBuffer.h.

size_t Ogre::HardwareBuffer::getSizeInBytes | ( | void |  | ) | const`[inherited]`

Returns the size of this buffer in bytes.

Definition at line 320 of file OgreHardwareBuffer.h.

Referenced by Ogre::HardwareBuffer::copyData().

Usage Ogre::HardwareBuffer::getUsage | ( | void |  | ) | const`[inherited]`

Returns the Usage flags with which this buffer was created.

Definition at line 322 of file OgreHardwareBuffer.h.

size_t Ogre::HardwareVertexBuffer::getVertexSize | ( | void |  | ) | const

Gets the size in bytes of a single vertex in this buffer.

Definition at line 63 of file OgreHardwareVertexBuffer.h.

bool Ogre::HardwareBuffer::hasShadowBuffer | ( | void |  | ) | const`[inherited]`

Returns whether this buffer has a system memory shadow for quicker reading.

Definition at line 326 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::isLocked | ( | void |  | ) | const`[inherited]`

Returns whether or not this buffer is currently locked.

Definition at line 328 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::isSystemMemory | ( | void |  | ) | const`[inherited]`

Returns whether this buffer is held in system memory.

Definition at line 324 of file OgreHardwareBuffer.h.

virtual void* Ogre::HardwareBuffer::lock | ( | size_t | offset,
|  | size_t | length,
|  | LockOptions | options |
| ) |  |  | `[virtual, inherited]`

Lock the buffer for (potentially) reading / writing.

Parameters:

  | offset | The byte offset from the start of the buffer to lock
  | length | The size of the area to lock, in bytes
  | options | Locking options

Returns:
  Pointer to the locked memory

Reimplemented in Ogre::DefaultHardwareVertexBuffer, Ogre::DefaultHardwareIndexBuffer, and Ogre::HardwarePixelBuffer.

Definition at line 180 of file OgreHardwareBuffer.h.

Referenced by Ogre::HardwareBuffer::copyData().

void* Ogre::HardwareBuffer::lock | ( | LockOptions | options | ) | `[inherited]`

Lock the entire buffer for (potentially) reading / writing.

Parameters:

  | options | Locking options

Returns:
  Pointer to the locked memory

Definition at line 210 of file OgreHardwareBuffer.h.

virtual void* Ogre::HardwareBuffer::lockImpl | ( | size_t | offset,
|  | size_t | length,
|  | LockOptions | options |
| ) |  |  | `[protected, pure virtual, inherited]`

Internal implementation of lock().

Implemented in Ogre::DefaultHardwareVertexBuffer, Ogre::DefaultHardwareIndexBuffer, and Ogre::HardwarePixelBuffer.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

virtual void Ogre::HardwareBuffer::readData | ( | size_t | offset,
|  | size_t | length,
|  | void * | pDest |
| ) |  |  | `[pure virtual, inherited]`

Reads data from the buffer and places it in the memory pointed to by pDest.

Parameters:

  | offset | The byte offset from the start of the buffer to read
  | length | The size of the area to read, in bytes
  | pDest | The area of memory in which to place the data, must be large enough to accommodate the data!

Implemented in Ogre::DefaultHardwareVertexBuffer, Ogre::DefaultHardwareIndexBuffer, and Ogre::HardwarePixelBuffer.

void Ogre::HardwareBuffer::suppressHardwareUpdate | ( | bool | suppress | ) | `[inherited]`

Pass true to suppress hardware upload of shadow buffer changes.

Definition at line 332 of file OgreHardwareBuffer.h.

virtual void Ogre::HardwareBuffer::unlock | ( | void |  | ) | `[virtual, inherited]`

Releases the lock on this buffer.

Remarks:
  Locking and unlocking a buffer can, in some rare circumstances such as switching video modes whilst the buffer is locked, corrupt the contents of a buffer. This is pretty rare, but if it occurs, this method will throw an exception, meaning you must re-upload the data.

  Note that using the 'read' and 'write' forms of updating the buffer does not suffer from this problem, so if you want to be 100% sure your data will not be lost, use the 'read' and 'write' forms instead.

Reimplemented in Ogre::DefaultHardwareVertexBuffer, and Ogre::DefaultHardwareIndexBuffer.

Definition at line 226 of file OgreHardwareBuffer.h.

Referenced by Ogre::HardwareBuffer::copyData().

virtual void Ogre::HardwareBuffer::unlockImpl | ( | void |  | ) | `[protected, pure virtual, inherited]`

Internal implementation of unlock().

Implemented in Ogre::DefaultHardwareVertexBuffer, and Ogre::DefaultHardwareIndexBuffer.

virtual void Ogre::HardwareBuffer::writeData | ( | size_t | offset,
|  | size_t | length,
|  | const void * | pSource,
|  | bool | discardWholeBuffer = `false` |
| ) |  |  | `[pure virtual, inherited]`

Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough.

Parameters:

  | offset | The byte offset from the start of the buffer to start writing
  | length | The size of the data to write to, in bytes
  | pSource | The source of the data to be written
  | discardWholeBuffer | If true, this allows the driver to discard the entire buffer when writing, such that DMA stalls can be avoided; use if you can.

Implemented in Ogre::DefaultHardwareVertexBuffer, Ogre::DefaultHardwareIndexBuffer, and Ogre::HardwarePixelBuffer.

## Member Data Documentation

bool Ogre::HardwareBuffer::mIsLocked`[protected, inherited]`

Definition at line 142 of file OgreHardwareBuffer.h.

size_t Ogre::HardwareBuffer::mLockSize`[protected, inherited]`

Definition at line 144 of file OgreHardwareBuffer.h.

size_t Ogre::HardwareBuffer::mLockStart`[protected, inherited]`

Definition at line 143 of file OgreHardwareBuffer.h.

HardwareBufferManagerBase* Ogre::HardwareVertexBuffer::mMgr`[protected]`

Definition at line 51 of file OgreHardwareVertexBuffer.h.

size_t Ogre::HardwareVertexBuffer::mNumVertices`[protected]`

Definition at line 52 of file OgreHardwareVertexBuffer.h.

HardwareBuffer* Ogre::HardwareBuffer::mpShadowBuffer`[protected, inherited]`

Definition at line 147 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::mShadowUpdated`[protected, inherited]`

Definition at line 148 of file OgreHardwareBuffer.h.

size_t Ogre::HardwareBuffer::mSizeInBytes`[protected, inherited]`

Definition at line 140 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::mSuppressHardwareUpdate`[protected, inherited]`

Definition at line 149 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::mSystemMemory`[protected, inherited]`

Definition at line 145 of file OgreHardwareBuffer.h.

Usage Ogre::HardwareBuffer::mUsage`[protected, inherited]`

Definition at line 141 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::mUseShadowBuffer`[protected, inherited]`

Definition at line 146 of file OgreHardwareBuffer.h.

size_t Ogre::HardwareVertexBuffer::mVertexSize`[protected]`

Definition at line 53 of file OgreHardwareVertexBuffer.h.

The documentation for this class was generated from the following file:

- OgreHardwareVertexBuffer.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:55